\NeedsTeXFormat{LaTeX2e}[1994/12/01]
\ProvidesClass{trifconf}[2025/02/24 For Trifonov's Conference]

\LoadClass[twoside,a5paper,10pt,final]{extarticle}

%\RequirePackage{hyperref}

\RequirePackage{inputenc}
\RequirePackage[T1,T2A]{fontenc}
\RequirePackage[russian]{babel}
\RequirePackage{indentfirst}
\RequirePackage[papersize={143mm,215mm},%
                total={114mm,190mm},includeheadfoot,%
                nohead,foot=20pt,left=14.5mm]{geometry}

\sloppy

\RequirePackage{amssymb}
\RequirePackage{amsmath}
\RequirePackage{amsthm}
\RequirePackage{amscd}
\RequirePackage{bm}
\RequirePackage{graphicx}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% specific global data follow

\newcommand{\YEAR}{2025}
\newcommand{\BOOKCOL}{-bookwide-colontitul-n-o-t--s-e-t-}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% specific commands follow

\newcommand{\thetitle}{-title--n-o-t--s-e-t-}
\renewcommand{\title}[1]{\renewcommand{\thetitle}{#1}}

\newcommand{\theauthors}{-authors--n-o-t--s-e-t-}
\newcommand{\authors}[1]{\renewcommand{\theauthors}{#1}}

\newcommand{\thebriefauthors}{-authors--n-o-t--s-e-t-}
\newcommand{\briefauthors}[1]{\renewcommand{\thebriefauthors}{#1}}

\newcommand{\theemail}{-email--n-o-t--s-e-t-}
\newcommand{\email}[1]{\renewcommand{\theemail}{#1}}

\renewcommand{\maketitle}{%
  \begin{center}%
    {\normalsize\textbf{\MakeUppercase{\thetitle}}\par}\medskip
    {\normalsize\theauthors}\\[1mm]
    {\small\texttt{\theemail}}\\[1mm]
  \end{center}
  \normalsize
  \addcontentsline{toc}{\thetitle}{\thebriefauthors}%
}

\let\href=\texttt
\let\Large\large

\newcommand\Section[1]{%
   \refstepcounter{section}%
   \section*{\raggedright\arabic{section}. #1}
}

\makeatletter
\@ifundefined{No}{\newcommand{\No}{\textnumero}}
\makeatother

\renewenvironment{abstract}
    {\par\medskip\leftskip=2em\rightskip=\leftskip\small\parindent=0pt\ignorespaces}
    {\par\medskip}

\inputencoding{utf8}
\newbox\KeyWordsName
\setbox\KeyWordsName=\hbox{\small\textbf{Ключевые слова:}}
\newcommand\keywords[1]{\par{\small\noindent\copy\KeyWordsName\ #1.}\par\medskip}


\def\newthm#1#2{%
  \newtheorem{#1}{\expandafter\protect\csname#1name\endcsname}%
  \newtheorem*{#1*}{\expandafter\protect\csname#1name\endcsname}%
  \expandafter\newbox\csname#1B\endcsname
  \expandafter\setbox\csname#1B\endcsname=\hbox{\textbf{#2}}%
  \expandafter\edef\csname#1name\endcsname{\copy\csname#1B\endcsname}%
}

\newthm{lemma}{Лемма}
\newthm{statement}{Утверждение}
\newthm{proposition}{Предложение}
\newthm{theorem}{Теорема}
\newthm{corollary}{Следствие}
\theoremstyle{definition}
\newthm{definition}{Определение}
\newthm{remark}{Замечание}

\def\resetcounters{%
  \setcounter{lemma}{0}%
  \setcounter{statement}{0}%
  \setcounter{proposition}{0}%
  \setcounter{theorem}{0}%
  \setcounter{corollary}{0}%
  \setcounter{definition}{0}%
  \setcounter{remark}{0}%
  \setcounter{figure}{0}%
  \setcounter{table}{0}%
}

\raggedbottom
